# ifndef __BALTAZAR__
///////////////////////////////////
//
//  Baltazar v5.00
//  (c)1995,1996,1997 SGP Systems
//
//
# define __BALTAZAR_VERSION__ 500 // v5.00

# pragma idchars = "젡Ԝ֐қՄӚш"

typedef long TypPedmt; // v4.00

// datum
typedef struct {
  int  Rok;   // 1980-2099
  unsigned char
    Msc,    // 1-12
    Den,      // 1-28,29,30,31
    DenTdne; // 0-6; 0=nedle, 1=pondl...
  } TypDatum;


built_in( 30) char* TxtPietzec( char* retezec );
built_in(249) void MyKonecObsluhy();
built_in( 28) void PepniNaText();
built_in(  6) void ekej( int zpozdeni );
built_in(283) unsigned HromadaVolnPam؜();
built_in( 25) int  tiKlvesuZFronty();
built_in( 65) void VyprzdniFrontuKlves();
# define KlScanDel                     96
built_in( 75) void EscPlus();

built_in( 67) void  GrNastavPozici( int x, int y );
built_in( 68) int   GrNastavBarvuPoped( int barva );
built_in( 77) int   GrNastavBarvuPozad( int barva );
built_in( 66) void  GrPietzec( char* text );
built_in( 72) void  GrPiLslo( long d, int delka );
built_in( 73) void  GrPiUslo( int d, int delka );
built_in( 59) TypDatum&  SystmovDatum( TypDatum& datum );

built_in( 43) void     Tn( unsigned vyska );
built_in( 44) void     VypniTn();
built_in(  2) unsigned Dlkaetzce( char* s );


// makra pro cyklus # (for)
# define OdDoKrok(var,od,do,krok)            \
           (var)= (od); (var)<=(do); (var)+= (krok)
# define OdDolDoKrok(var,od,do,krok)        \
           (var)= (od); (var)>=(do); (var)-= (krok)
# define Od0(var,kolikrat)                      \
           (var)= 0; (var)<(kolikrat); ++(var)
# define DolDo0(var,kolikrat)                  \
           (var)= ((kolikrat)-1); (var)>=0; --(var)

built_in(  0) void      putchar( char c );
built_in(  1) int       getchar();
built_in(  2) unsigned  strlen( char* s );

/////////////////////////////////
//
//  main() mus mt tento tvar:
    extern void main();

///////////////
//
//  KONSTANTY
//

// barvy
# define ern            0
# define Tmavozelen      1
# define Modr            2
# define Tmavomodr       3
# define Fialovorov    4
# define ervenohnd     5
# define Krmov          6
# define Svtloed       7
# define Tmavoed        8
# define Svtlozelen     9
# define Svtlomodr      10
# define Fialov          11
# define erven          12
# define Oranov         13
# define lut            14
# define Bl             15

// ekn
# define NaKlvesu        ((int)0x8001)


////////////////
//
//  verze 3.08
//

////////////////
//
//  verze 3.10
//

// makra pro cyklus # (for)
# define OdDoKrok(var,od,do,krok) \
           (var)= (od); (var)<=(do); (var)+= (krok)
# define OdDolDoKrok(var,od,do,krok) \
           (var)= (od); (var)>=(do); (var)-= (krok)
# define Od0(var,kolikrat) \
           (var)= 0; (var)<(kolikrat); ++(var)
# define DolDo0(var,kolikrat)\
           (var)= ((kolikrat)-1); (var)>=0; --(var)

built_in(105) int GrafickKarta();
# define KartaCGA   1
# define KartaEGA   3
# define KartaHerc  7
# define KartaVGA   9
# define KartaVESA 10

////////////////
//
//  verze 3.20
//

built_in(104) int  DOSProve( char* radkovy_prikaz_DOSu );

////////////////
//
//  verze 3.3+
//


built_in(115) int  GrNastavBarvy( int barvy );


//////////////////////
//
//  verze 4.00, 5.00
//

// klvesa
built_in(2)   int      gKlvesa;


//
built_in( 48) double abs( double r );

built_in(153) long   StrNaLslo( char* retezec, int* chyba );
built_in(154) double StrNaDslo( char* retezec, int* chyba );

built_in(155) char* LsloNaetzec( char* retezec, long cislo, int delka );
built_in(156) char* DsloNaetzec( char* retezec, double cislo,
                                     int delka, int desetinna_delka );

built_in(163) void GrNastavPaletu( TypPedmt cislo_predmetu );

built_in(166) long RychlostCPU();
built_in(333) void ekejNaVR();

// grafika
# define GrkaPolka  39
# define GrVkaPolka  29

built_in(175) void GrNastavPoziciRel( int x, int y );
built_in(176) int  GrNastavVstup( int vystup, ...);

# define GrVstupOknko               0
# define GrVstupOkno                 1
# define GrVstupPlocha               2
# define GrVstupUivatelsk1         3
# define GrVstupUivatelsk2         4
# define GrVstupUivatelsk3         5
# define GrVstupUivatelsk4         6
# define GrVstupUivatelskNastaven 8

# define GrVstupOknkoX 229
# define GrVstupOknkoY 310
# define GrVstupOknoX    25
# define GrVstupOknoY    11

typedef unsigned char TypGrVplVzorek[8];

built_in(177) void GrNastavVpl( int druh, ...);

# define GrVplPln   0
# define GrVplVzorek 1

built_in(178) void GrNastavLinku( int druh, ...);

# define GrLinkaPln   1
# define GrLinkaVzorek 2
# define GrLinkaTenk  4
# define GrLinkaTlust 8

# define GrLinkaZpsobKreslenNormln 0x10
# define GrLinkaZpsobKreslenXor      0x20


built_in(179) int GrNastavText( int druh );

# define GrTextSPozadm  0
# define GrTextBezPozad 1

built_in(180) void GrKresliObdlnk( int X1, int Y1, int X2, int Y2 );
built_in(181) void GrKresliVyplnnObdlnk( int X1, int Y1, int X2, int Y2 );
built_in(182) void GrKresliElipsu( int x, int y,
                                   double pocatecni_uhel, // radiny
                                   double koncovy_uhel,   // radiny
                                   unsigned x_polomer,
                                   unsigned y_polomer );
built_in(183) void GrKresliLinku( int X1, int Y1, int X2, int Y2 );
built_in(186) void GrKresliMnohohelnk( unsigned pocet_bodu,
                                         int X1, int Y1, ...);
built_in(189) int  GrBarvaBodu( int x, int y );
built_in(190) void GrKresliBod( int x, int y, int barva );
built_in(191) int  GrKresliPedmt( TypPedmt predm, int transparentn,
                                    int x, int y );
built_in(316) int  GrKresliPedmty( TypPedmt predm, int transparentn,
                                     int x, int y, int , int v );
built_in(329) int  GrNatiBMP( int x, int y, char* JmnoSouboru,
                               int BMPx, int BMPy, int BMPw, int BMPh,
                               int BMPPaleta );
built_in(330) int  GrUloBMP( int x, int y, int w, int h, char* JmnoSouboru );


typedef struct {
  int X, Y, X1, Y1, X2, Y2;
  } TypGrPoziceOblouku;

built_in(193) void GrPoziceOblouku( TypGrPoziceOblouku& obl_poz );

built_in(194) int  GrMaxX();
built_in(195) int  GrMaxY();

# define GrMdEGA           1
# define GrMdVGA           2
# define GrMdVESA800x600   3
# define GrMdVESA1024x768  4
# define GrMdVESA1280x1024 5
built_in(196) int  GrNastavMd( int Md );
built_in(312) int  GrMd();
built_in(314) void GrNastavBarvuPalety( int slo, int R, int G, int B );
built_in(326) void GrBarvaPalety( int slo, int& R, int& G, int& B );
built_in(307) int  GrtiSetzec( char* prompt, string& retezec, int pocet_znaku, int edituj_obsah, int barvy );
built_in(320) int  GrdkovEditor( string& retezec, int pocet_znaku, int pozice, int blok_zacatek, int blok_konec, int barvy );

// argumenty a promnn DOSu
built_in(197) int      DOSPoetArgument();
built_in(198) string   DOSArgument( int slo );
built_in(199) string   DOSPromnn( char* Jmno );
built_in(200) unsigned DOSVerze();
built_in(201) int      DOSChyba();

// disk a adrese ( A=adres, AP=poloka adrese )
built_in(203) long DiskVolnMsto( int jednotka );
built_in(204) long DiskVelikost( int jednotka );

built_in(205) int    AdresVytvo( char* cesta );
built_in(206) int    AdresSma( char* cesta );
built_in(207) string AdresAktuln( int Jednotka );
built_in(208) int    AdresNastavAktuln( char* cesta );

typedef struct {
  char _reserved[21];
  unsigned char Atributy;
  long DatumAas;
  long Velikost;
  char Jmno[13];
  } TypPolokaAdrese;

built_in(209) int  PolokaAdreseNajdiPrvn( char* cesta, unsigned Atributy,
                                              TypPolokaAdrese& apol );
built_in(210) int  PolokaAdreseNajdiDal( TypPolokaAdrese& apol );

// soubory ( S=soubor )
typedef long TypSoubor;

built_in(213) int    SouborNulujChybu( TypSoubor s );
built_in(221) int    SouborExistuje( char* Jmno );
built_in(214) string SouborAbsolutnCesta( char* Jmno );
built_in(215) string SouborHledej( char* Jmno, char* SeznamAdres );
built_in(216) int    SouborRozdlCestu( char* Cesta,
                                        string& Adres, string& Jmno,
                                        string& Ppona );
// atributy souboru
# define SouborAtributPouzeten 0x01
# define SouborAtributSkryt     0x02
# define SouborAtributSystmov  0x04
# define SouborAtributSvazek     0x08
# define SouborAtributAdres    0x10
# define SouborAtributArchivn   0x20

built_in(217) unsigned SouborAtributy( char* Jmno );
built_in(218) int      SouborNastavAtributy( char* Jmno, unsigned Atributy );

built_in(219) int SouborSma( char* Jmno );
built_in(220) int SouborPejmenuj( char* stare_jmeno, char* nove_jmeno );

// pstup k souboru
# define SouborPstupten 0x01 // ten
# define SouborPstupZpis 0x02 // zpis
// je-li instalovn SHARE.EXE
# define SouborPstupOdepiten       0x30 // odepi ten
# define SouborPstupOdepiZpis       0x20 // odepi zpis
# define SouborPstupOdepitenIZpis 0x10 // odepi ten a zpis
# define SouborPstupPovolVe          0x40 // neodepi nic
# define SouborPstupPrivtn          0x80
// formt
# define SouborPstupTextov 0x100
# define SouborPstupBinrn 0x200

built_in(222) TypSoubor SouborOtevi( char* Jmno, unsigned pristup );
built_in(223) int SouborZapiBuffer( TypSoubor s );
built_in(224) int SouborZavi( TypSoubor& s );
built_in(225) int SouborUzni( TypSoubor s );

built_in(226) unsigned SoubortiBlok( TypSoubor s, void* blok, unsigned Velikost );
built_in(227) int      SoubortiZnak( TypSoubor s );
built_in(228) unsigned SoubortiCetzec( TypSoubor s, char* retezec, unsigned max_delka );
built_in(247) unsigned SoubortiSetzec( TypSoubor s, string& retezec );

built_in(229) unsigned SouborPiBlok( TypSoubor s, void* blok, unsigned Velikost );
built_in(230) int SouborPiZnak( TypSoubor s, char c );
built_in(231) int SouborPietzec( TypSoubor s, char* retezec );

built_in(232) int SouborDataPlatn( TypSoubor s );
built_in(321) int SouborKonec( TypSoubor s );
built_in(233) int SouborChyba( TypSoubor s );

built_in(322) unsigned SouborHandle( TypSoubor s );
built_in(323) int SouborJeZazen( TypSoubor s );
built_in(324) int SouborPipravenProten( TypSoubor s );
built_in(325) int SouborPipravenProZpis( TypSoubor s );

// nastaven pozice souboru odkud
# define SouborPoziceOdZatku  0
# define SouborPoziceOdAktuln 1
# define SouborPoziceOdKonce    2

built_in(234) long SouborPozice( TypSoubor s );
built_in(235) long SouborNastavPozici( TypSoubor s, long pozice, int odkud );
built_in(236) long SouborVelikost( TypSoubor s );




built_in(239) int SouborPiLslo( TypSoubor s, long d, int delka );
built_in(240) int SouborPiUslo( TypSoubor s, unsigned d, int delka );
built_in(241) int SouborPiDslo( TypSoubor s, double d, int delka, int desetinna_delka );
# define          SouborPiNovdek(s) (SouborPiZnak((s),'\n'))

built_in(242) int SoubortiIslo( TypSoubor s, int& cele_cislo );
built_in(243) int SoubortiUslo( TypSoubor s, unsigned& prirozene_cislo );
built_in(244) int SoubortiDslo( TypSoubor s, double& realne_cislo );
built_in(245) int SoubortiLslo( TypSoubor s, long& velke_cele_cislo );
built_in(246) int SoubortiNovdek( TypSoubor s );

// my
typedef struct {
  char Typ;
  char Tlatka;
  int  X, Y;
  long as;
  } TypMyUdlost;

built_in(0) TypMyUdlost gMyUdlost;

typedef struct {
  int  X, Y;
  char Tlatka;
  } TypMyStav;

// tlatka myi (maska)
#define MyTlLev       1 // lev tlatko dreno
#define MyTlPrav      2 // prav tlatko dreno
#define MyTlProstedn 4 // stedn tlatko dreno
#define MyTlShift      8 // Shift peaova dren
#define MyTlCtrl      16 // Ctrl peaova dren
#define MyTlAlt       32 // Alt peaova dren
#define MyUdlostLevTlDol           2 // lev tlatko dol - dreno

built_in(248) int MyZatekObsluhy();
built_in(251) void MySchovejKurzor();
built_in(253) void MytiUdlost( TypMyUdlost& udalost );
built_in(254) void MyNastavPozici( int x, int y );
built_in(255) void MyNastavRozsah( int minx, int miny, int maxx, int maxy );




// obsluha klvesnice
typedef struct {
  char Typ;
  char Klvesa;
  unsigned Peaovae;
  long as;
  } TypKlUdlost;

built_in(1) TypKlUdlost gKlUdlost;


#define KlPeaovaCtrl        (1<< 2) // libovoln Ctrl stisknuta

#define KlPeaovaStavScrollLock (1<< 4) // pepna ScrollLock zapnut
#define KlPeaovaStavNumLock    (1<< 5) // pepna NumLock zapnut
#define KlPeaovaStavCapsLock   (1<< 6) // pepna CapsLock zapnut
#define KlPeaovaStavInsert     (1<< 7) // pepna Insert zapnut

built_in(260) void KlZatekObsluhy( int AutoOpakovn );
built_in(261) void KlKonecObsluhy();
built_in(262) int  KlKlvesaStisknuta( int Klvesa );
built_in(263) unsigned KlPeaovae();
built_in(264) void KltiUdlost( TypKlUdlost& udalost );
built_in(265) void KlVyprzdniFrontuUdlost();

// animovan objekty
typedef long TypAnimPedmt;

built_in(267) TypAnimPedmt AnimPedmtVytvo( TypPedmt prvn_pedmt,
                               unsigned poet_pedmt,
                               int md_animace, int transparentn );

built_in(269) void AnimPedmtAnimuj( TypAnimPedmt objekt,
                     int x, int y, int slo_fze );
built_in(270) void AnimPedmtSchovej( TypAnimPedmt objekt );
built_in(271) int  AnimNastavGrVstup( int vstup );
built_in(274) int  AnimPedmtFze( TypAnimPedmt objekt );
built_in(275) void AnimPedmtDejPed( TypAnimPedmt objekt,
                                     TypAnimPedmt ped_co );



// string
built_in(285) unsigned StrVelikost( string& Str );
built_in(286) string&  StrNastavVelikost( string& Str, unsigned Velikost );
built_in(  2) unsigned StrDlka( char* Str );

built_in(287) string&  StrVlo( string& Str, string Str2, unsigned Pozice );
built_in(288) string&  StrSma( string& Str, unsigned Pozice, unsigned Poet );
built_in(327) int      StrSmaPodetzec( string& Str, unsigned Pozice, char* SubStr );
built_in(328) unsigned StrPozicePodetzce( char* Str, unsigned Pozice, char* SubStr );
built_in(289) string   StrKopie( char* Str, unsigned Pozice, unsigned Poet );
built_in(290) string   StrLslo( long slo, int Dlka );
built_in(291) string   StrDslo( double slo, int Dlka, int DesetinnDlka );

built_in(292) string&  StrVytvo( string& Str );
built_in(293) string&  StrZru( string& Str );

built_in(308) string   StrNaMal( char* Str );
built_in(309) string   StrNaVelk( char* Str );
built_in(310) string   StrBezDiakritiky( char* Str );
built_in(311) string   StrZnak( int Znak, unsigned Poet );

built_in(294) string   ProgramCesta();


built_in(296) long SystmovTikot();

// datum
built_in(297) int       DatumPlatn( TypDatum& Datum );
built_in(298) TypDatum& DatumPosu( TypDatum& Datum, int Roky, int Msce, long Dny );
built_in(299) long      DatumRozdl( TypDatum& Datum1, TypDatum& Datum2 );
built_in(300) TypDatum& DatumNastavDenTdne( TypDatum& Datum );


built_in(268) void AnimPedmtZru( TypAnimPedmt& objekt );



# define __BALTAZAR__
# endif
